Index: cpukit/include/rtems/score/stackimpl.h
===================================================================
--- cpukit/include/rtems/score/stackimpl.h	(revision 9dad73569784f986dce33342ba4cd51b446e813c)
+++ cpukit/include/rtems/score/stackimpl.h	(revision 08cbd4ba201317d0f529cbdb48db9f4775804963)
@@ -120,11 +120,13 @@
 
 /**
- * @brief Extend the stack size to account for additional data structures
- *   allocated in the stack area of a thread.
+ * @brief Extends the stack size to account for additional data structures
+ *   allocated in the thread storage area.
  *
- * @param stack_size The stack size.
- * @param is_fp Indicates if the stack is for a floating-point thread.
+ * @param stack_size is the stack size.
  *
- * @return The extended stack size.
+ * @param is_fp shall be true, if the stack is for a floating-point thread,
+ *   otherwise it shall be false.
+ *
+ * @return Returns the extended stack size.
  */
 RTEMS_INLINE_ROUTINE size_t _Stack_Extend_size(
@@ -133,7 +135,12 @@
 )
 {
+  size_t extra_size;
+
+  extra_size = _TLS_Get_allocation_size();
+
 #if ( CPU_HARDWARE_FP == TRUE ) || ( CPU_SOFTWARE_FP == TRUE )
   if ( is_fp ) {
-    stack_size += CONTEXT_FP_SIZE;
+    /* This addition cannot overflow since the TLS size cannot be that large */
+    extra_size += CONTEXT_FP_SIZE;
   }
 #else
@@ -141,5 +148,12 @@
 #endif
 
-  stack_size += _TLS_Get_allocation_size();
+  stack_size += extra_size;
+
+  if ( stack_size < extra_size ) {
+    /*
+     * In case of an unsigned integer overflow, saturate at the maximum value.
+     */
+    stack_size = SIZE_MAX;
+  }
 
   return stack_size;
